#include <iostream>
#include <cstdio>
using namespace std;

int const dx[8] = {-1,-1,-1,0,0,1,1,1};
int const dy[8] = {-1,0,1,-1,1,-1,0,1};

struct fig {
	int x,y;
	fig():x(-1),y(-1) {}
	fig(int x, int y):x(x),y(y) {}
} black_king, white_king, white_rook;

void read_coord(fig& f) {
	char st[100];
	gets(st);

	f.x = st[0]-'a';
	f.y = st[1]-'1';
}

int equal_fig(fig a, fig b) {
	return a.x == b.x && a.y == b.y;
}

int white_king_beat_point(fig p) {
	for (int k=0; k<8; k++)
		if (p.x == white_king.x + dx[k] &&
			p.y == white_king.y + dy[k])
			return 1;
	return 0;
}

int white_rook_beat_point(fig p) {
	int nnew[8][8];
	for (int i=0; i<8; i++)
		for (int j=0; j<8; j++)
			nnew[i][j] = 0;

	int x,y;

	x = white_rook.x;
	y = white_rook.y;

	while (x >= 0 && !equal_fig(fig(x,y), white_king)) {
		nnew[x][y] = 1;
		x--;
	}

	x = white_rook.x;
	y = white_rook.y;

	while (x < 8 && !equal_fig(fig(x,y), white_king)) {
		nnew[x][y] = 1;
		x++;
	}

	x = white_rook.x;
	y = white_rook.y;

	while (y >= 0 && !equal_fig(fig(x,y), white_king)) {
		nnew[x][y] = 1;
		y--;
	}

	x = white_rook.x;
	y = white_rook.y;

	while (y < 8 && !equal_fig(fig(x,y), white_king)) {
		nnew[x][y] = 1;
		y++;
	}

	if (nnew[p.x][p.y])
		return 1;

	return 0;
}

int beaten(fig posit) {
	if (!equal_fig(posit, white_king))
		if (white_king_beat_point(posit))
			return 1;
	if (!equal_fig(posit, white_rook))
		if (white_rook_beat_point(posit))
			return 1;
	return 0;
}

int can_move(fig from) {
	for (int k=0; k<8; k++) {
		fig new_p;
		new_p.x = from.x + dx[k];
		new_p.y = from.y + dy[k];

		if (new_p.x >= 0 && new_p.x < 8 && new_p.y >= 0 && new_p.y < 8) {
			if (!beaten(new_p))
				return 1;
		}
	}
	return 0;
}

int main() {
	read_coord(black_king);
	read_coord(white_king);
	read_coord(white_rook);

	if (!beaten(black_king)) {
		if (can_move(black_king)) {
			printf("NOTHING");
			return 0;
		}
		else {
			printf("STALEMATE");
			return 0;
		}
	}

	if (can_move(black_king)) {
		printf("CHECK");
		return 0;
	}
	else {
		printf("MATE");
		return 0;
	}

	return 0;
}
