#include <iostream>
#include <cstdio>
using namespace std;

int const MAX_N = 1100;
int const MAX_TREE = 2048;
long long const INF = 1000000000000000000LL;

long long tree_min[2*MAX_TREE], tree_max[2*MAX_TREE];

void update_min(int v, long long add_value, int prisv) {
	v += MAX_TREE;

	if (prisv)
		tree_min[v] = add_value;
	else
		tree_min[v] += add_value;
	
	while (v>1) {
		tree_min[v>>1] = min(tree_min[v], tree_min[v^1]);
		v >>= 1;
	}
}

void update_max(int v, long long add_value, int prisv) {
	v += MAX_TREE;
	
	if (prisv)
		tree_max[v] = add_value;
	else
		tree_max[v] += add_value;

	while (v>1) {
		tree_max[v>>1] = max(tree_max[v], tree_max[v^1]);
		v >>= 1;
	}
}

long long find_min(int l, int r) {
	l += MAX_TREE;
	r += MAX_TREE;
	long long ans = INF;

	while (l <= r) {
		if (l&1) ans = min(ans, tree_min[l]);
		if (!(r&1)) ans = min(ans, tree_min[r]);
		l = (l+1)/2;
		r = (r-1)/2;
	}

	return ans;
}

long long find_max(int l, int r) {
	l += MAX_TREE;
	r += MAX_TREE;
	long long ans = -INF;

	while (l <= r) {
		if (l&1) ans = max(ans, tree_max[l]);
		if (!(r&1)) ans = max(ans, tree_max[r]);
		l = (l+1)/2;
		r = (r-1)/2;
	}

	return ans;
}

int main() {
	for (int i=0; i<2*MAX_TREE; i++) {
		tree_min[i] = INF;
		tree_max[i] = -INF;
	}

	int n;
	cin>>n;
	for (int i=0; i<n; i++) {
		long long x;
		cin>>x;

		update_min(i,x,1);
		update_max(i,x,1);
	}

	int m;
	cin>>m;
	for (int i=0; i<m; i++) {
		int tp;
		cin>>tp;

		if (tp == 0) {
			int v1,v2;
			long long prodal;
			cin>>v1>>v2>>prodal;
			v1--; v2--;

			update_min(v1, -prodal, 0);
			update_max(v1, -prodal, 0);

			update_min(v2, prodal, 0);
			update_max(v2, prodal, 0);
		}
		else if (tp == 1) {
			int v1,v2;
			cin>>v1>>v2;
			v1--; v2--;

			cout<<(find_max(v1,v2) - find_min(v1,v2))<<"\n";
		}
	}

	return 0;
}
