#include <iostream>
#include <cstdio>
#include <map>
#include <queue>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

#define bit(i) (1<<(i))
int n,m;

int dy[]={-1,0,1,0};
int dx[]={0,1,0,-1};
char step[]="urdl";
char push[]="URDL";

inline bool check(int mask,int i,int j) {
	return (mask & bit(i*m+j))!=0;
}

inline void setbit(int& mask, int i,int j) {
	mask |= bit(i*m+j);
}

inline void unsetbit(int& mask, int i,int j) {
	if (check(mask,i,j))
		mask ^= bit(i*m+j);
}

inline bool inside(int y,int x) {
	return y>=0 && y<n && x>=0 && x<m;
}

inline int code(int mask,int i,int j) {
	return mask | i << 25 | j << 28;
}

inline void decode(int code, int& mask, int& i, int& j) {
	mask = code & (bit(25)-1);
	i = (code >> 25) & 7;
	j = (code >> 28) & 7;
}

int main() {
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);

	cin>>n>>m;

	vector<string> mas(n);
	vector<vector<pair<int,int> > > pos(10);

	pair<int,int> start;

	int boxes=0;
	int need=0;

	for (int i=0;i<n;i++) {
		cin>>mas[i];
		for (int j=0;j<m;j++) {
			if (isdigit(mas[i][j]))
				pos[mas[i][j]-'0'].push_back(make_pair(i,j));
			else if (mas[i][j]=='s' || mas[i][j]=='S') {
				if (mas[i][j]=='S')
					setbit(need,i,j);
				start=make_pair(i,j);
				mas[i][j]='.';
			}
			else if (mas[i][j]=='b' || mas[i][j]=='B') {
				if (mas[i][j]=='B')
					setbit(need,i,j);
				setbit(boxes, i,j);
				mas[i][j]='.';
			}
			else if (mas[i][j]=='x') {
				setbit(need,i,j);
				mas[i][j]='.';
			}
		}
	}

	queue<int> q;
	map<int, int> prev;
	map<int, char> symb;

	q.push(code(boxes, start.first, start.second));
	prev[code(boxes, start.first, start.second)] = -1;

	while (!q.empty()) {
		int cur=q.front();
		q.pop();

		int mask,y,x;
		decode(cur,mask,y,x);

		if (mask == need) {
			string res="";
			for (int v=cur;;v=prev[v]) {
				int pr = prev[v];
				if (pr==-1)
					break;
				res+=symb[v];
			}
			reverse(res.begin(),res.end());
			cout<<res;
			return 0;
		}

		for (int l=0;l<4;l++) {
			int yy = y+dy[l];
			int xx = x+dx[l];

			if (inside(yy,xx) && mas[yy][xx]!='#' && !check(mask,yy,xx)) {
				if (isdigit(mas[yy][xx])) {
					int tlp = mas[yy][xx] - '0';
					int ind = (make_pair(yy,xx)==pos[tlp][0]?0:1);
					yy = pos[tlp][1-ind].first;
					xx = pos[tlp][1-ind].second; 
				}
				int to = code(mask,yy,xx);
				if (prev.find(to)==prev.end()) {
					prev[to] = cur;
					symb[to] = step[l];
					q.push(to);
				}
			}
			else {
				int yy2=yy+dy[l];
				int xx2=xx+dx[l];

				if (inside(yy2,xx2) && check(mask,yy,xx) && mas[yy2][xx2]=='.' && !check(mask,yy2,xx2))	{
					int newmask = mask;
					unsetbit(newmask,yy,xx);
					setbit(newmask,yy2,xx2);

					int to = code(newmask, yy,xx);

					if (prev.find(to)==prev.end()) {
						prev[to]=cur;
						symb[to]=push[l];
						q.push(to);
					}
				}
			}
		}
	}

	return 0;
}
